Attribute VB_Name = "Conv"

'************************************************************
'* NOM : Conv.bas v1.2
'* DATE : 14/11/1998
'*
'* AUTEUR : Le Tigre
'*
'* CODE TROUVE SUR "Le petit monde de Visual Basic"
'*                 http://www.vbasic.org
'*
'* DESCRIPTION :
'* Permet d'effectuer des conversions entre diffrentes
'* reprsentations de valeurs
'*
'************************************************************



' Module pour Visual Basic
' Fonctions de conversion Hexa/Dcimal/Binaire
'
' Nom: Hex2Bin
' Appel: nb_bin = Hex2Bin(nb_hex)
'
' Nom: Hex2Dec
' Appel: nb_dec = Hex2Dec(nb_hex)
'
' Nom: Bin2Dec
' Appel: nb_dec = Bin2Dec(nb_bin)
'
' Nom: Bin2Hex
' Appel: nb_hex = Bin2Hex(nb_bin)
'
' Nom: Dec2Bin
' Appel: nb_bin = Dec2Bin(nb_dec)
'
' Nom: Dec2Hex
' Appel: nb_hex = Dec2Hex(nb_dec)
'
' Copyright (c) 1996 by BRUNEL Olivier dit Le Tigre
'****************************************************
'Dclarat pour la conver
Dim x, reste
Dim le_reste(50)
Public decimale As Double

Function Bin2Dec(le_chiffre_bin)
'Conversion BIN2DEC ** (c) Le Tigre
'crit par Le Tigre; 11/08/1996
'Dernire modif: 12/08/1996
'''''''''''''''''''''''''''''''''''''''''''''''
'Now c le decryptage du nb binaire!!
'nb de caractR ds le chif binR
taille = Len(le_chiffre_bin)
'la boucle finale...
For I = taille To 1 Step -1
 'On lit le caractR
 w = Mid(le_chiffre_bin, (taille - I) + 1, 1)
 If w = 1 Then
  'On le compte | on add: 2 puissance w
  decimale = decimale + (2 ^ (I - 1))
 End If
Next I

'Le chiffre final tant espr est dans decimal

'Vidage... ;)
x = 0: reste = 0: res = 0
For I = 1 To 50
 le_reste(I) = 0
Next I
I = 0: u = 0: y = 0: nb_caractR = 0: nb_hex = ""
le_chiffre = "": le_chiffre_dec = 0: le_chiffre_en_dec = 0

'That's all folks!
Bin2Dec = decimal
End Function

Function Bin2Hex(le_chiffre_bin)
'Conversion BIN2HEX ** (c) Le Tigre
'crit par Le Tigre; 03/08/1998
'''''''''''''''''''''''''''''''''''''''''''''''
w = Bin2Dec(le_chiffre_bin)
Bin2Hex = Dec2Hex(w)
End Function

Sub Binaire(le_chiffre_en_dec)
'Ss-pgm de conversions ** (c) Le Tigre
'crit par Le Tigre; 11/08/1996
'Dernire modif: 11/08/1996

'   On passe par le binaire...
'Dclarat
Dim y
Dim z As Double
'Vidage...;)
'y = 0: z = 0: x = 0: reste = 0
'Binaire = 2; division par 2 ! ;)
z = le_chiffre_en_dec / 2
'Comme ya des "," alors....(bordel!)
y = InStr(z, ","): If y = 0 Then y = Len(z) + 1
x = Mid(z, 1, y - 1)
'et hop...
y = InStr(z, ",")
If y = 0 Then
 'pas de reste
 reste = 0
Else
 'un reste...
 'on recup le chif after ","
 reste = Mid(z, y + 1, Len(z) - (y + 1))
 'on y add "0," dvt !!  et oui...
 reste = "0," & reste
 'on le *2 car c comme ca! ;))
 reste = reste * 2
 'Rem: de tte facon reste=0 ou reste=1 c tout!
End If

End Sub

Function Dec2Bin(le_chiffre_dec)
'Conversion BIN2DEC ** (c) Le Tigre
'crit par Le Tigre; 03/08/1996
'''''''''''''''''''''''''''''''''''''''''''''''
w = Dec2Hex(le_chiffre_dec)
Dec2Bin = Hex2Bin(w)
End Function

Function Dec2Hex(le_chiffre_dec)
'Conversion BIN2DEC ** (c) Le Tigre
'crit par Le Tigre; 03/08/1996
'''''''''''''''''''''''''''''''''''''''''''''''
Dec2Hex = Hex(le_chiffre_dec)
End Function

Function Hex2Bin(nb_hex As String)
'Conversion HEX2BIN ** (c) Le Tigre
'crit par Le Tigre; 11/08/1996
'Dernire modif: 12/08/1996
'''''''''''''''''''''''''''''''''''''''''''''''
'Dclarat
Dim nb_caractR As Integer
Dim le_chiffre As String
Dim le_chiffre_dec As Integer
Dim le_chiffre_bin 'As KeDalle
'Protect
decimale = 0
'mise en maj
nb_hex = UCase(nb_hex)
'vrif
If nb_hex = "0" Then
 decimale = 0
 Exit Function
End If
'nb de caractR
nb_caractR = Len(nb_hex)
'boucle d'analyse
For I = 1 To nb_caractR
 'ds nb_hex le caractR en I
 le_chiffre = Mid$(nb_hex, I, 1)
 'Convers en dcimal
 Select Case le_chiffre
  Case "A": le_chiffre_dec = 10
  Case "B": le_chiffre_dec = 11
  Case "C": le_chiffre_dec = 12
  Case "D": le_chiffre_dec = 13
  Case "E": le_chiffre_dec = 14
  Case "F": le_chiffre_dec = 15
  Case Else: le_chiffre_dec = Val(le_chiffre)
End Select
'''''''''''''''''''''''''''''''''''''''''''''''
'P'tite partie binaire!  ;)
If le_chiffre_dec = 0 Then
 res = 0
 GoTo jump
End If
Binaire le_chiffre_dec
'result: x et reste
u = 1
If x = "" Then le_reste(1) = reste
If x = "" Then x = 0
While x <> 0
 le_reste(u) = reste
 Binaire x
 If x = "" Then x = 0
 u = u + 1
Wend
'c obliger! ;)
u = u - 1

'res = le nb en binaire!!   enfin!;)
res = 1
jump:
While u <> 0
 res = res & le_reste(u)
 u = u - 1
Wend
'comme c sur 4 digits
If Len(res) < 4 Then
 res = String(4 - Len(res), "0") & res
End If
'''''''''''''''''''''''''''''''''''''''''''''''
'Mise en place D'UN nb binaire...
le_chiffre_bin = le_chiffre_bin & res
'La FIN!! si si; c elle! ;)
Next I


'Vidage... ;)
x = 0: reste = 0: res = 0
For I = 1 To 50
 le_reste(I) = 0
Next I
I = 0: u = 0: y = 0: nb_caractR = 0: nb_hex = ""
le_chiffre = "": le_chiffre_dec = 0: le_chiffre_en_dec = 0

'That's all folks!
Hex2Bin = le_chiffre_bin
End Function

Function Hex2Dec(nb_hex As String)
'Conversion HEX2DEC ** (c) Le Tigre
'crit par Le Tigre; 11/08/1996
'Dernire modif: 12/08/1996
'''''''''''''''''''''''''''''''''''''''''''''''
'Dclarat
Dim nb_caractR As Integer
Dim le_chiffre As String
Dim le_chiffre_dec As Integer
Dim le_chiffre_bin 'As KeDalle
'Protect
decimale = 0
'mise en maj
nb_hex = UCase(nb_hex)

'Conversion Hex2Bin
le_chiffre_bin = Hex2Bin(nb_hex)
'Conversion Bin2Dec
decimale = Bin2Dec(le_chiffre_bin)


'Vidage... ;)
x = 0: reste = 0: res = 0
For I = 1 To 50
 le_reste(I) = 0
Next I
I = 0: u = 0: y = 0: nb_caractR = 0: nb_hex = ""
le_chiffre = "": le_chiffre_dec = 0: le_chiffre_en_dec = 0


'That's all folks!
Hex2Dec = decimal
End Function


